#version 400

in vec3 Vertex;
in vec3 Normal;

uniform vec3 Extents;
uniform mat4 ModelMatrix;
uniform mat4 ModelViewProjectionMatrix;

out vec3 VNormal;

void main()
{
	vec3 vertex = Vertex * Extents;
	
	VNormal = normalize((ModelMatrix * vec4(Normal, 0.0)).xyz);
	
	gl_Position = ModelViewProjectionMatrix * vec4(vertex, 1.0);
}
