#version 400

in vec2 Vertex;

in vec2 TexOriginAndSize;
in vec4 PositionAndSize;

uniform mat4 ProjectionMatrix;

out vec2 VTexCoords;

void main()
{
	float TexOrigin = TexOriginAndSize.x;
	float TexSize = TexOriginAndSize.y;
	
	VTexCoords = vec2(TexOrigin + Vertex.x * TexSize, Vertex.y);
	
	vec2 Position = PositionAndSize.xy;
	vec2 Size = PositionAndSize.zw;
	
	gl_Position = ProjectionMatrix * vec4(Position + Vertex * Size, 0.0, 1.0);
}
