#version 400

// TODO: 
// All the GBuffer stuff should be in a separate file (cleaner, no duplication).
// LoadShader() should pass all sources of each type (e.g. .frag) to a ShaderObject.
// (And prepend "#version 400" as another source string).

layout(location = 0) out vec4 GBuffer0;
layout(location = 1) out vec4 GBuffer1;

void SetAlbedo(vec3 albedo)
{
	GBuffer0.rgb = albedo;
}

void SetSpecularStrength(float value)
{
	GBuffer0.a = value;
}

void SetNormal(vec3 normal)
{
	GBuffer1.xyz = normal * 0.5 + 0.5;
}

float TAG_SCENE = 0.0;
float TAG_SKYBOX = 1.0 / 255.0;

void SetTag(float tag)
{
	GBuffer1.a = tag;
}

in vec3 VNormal;

uniform vec3 Color;

void main()
{
	SetAlbedo(Color);
	SetSpecularStrength(0.0);
	SetNormal(VNormal);
	SetTag(TAG_SCENE);
}
