#version 400

in vec3 Vertex;
in vec3 Normal;

uniform float Size;

uniform mat4 ModelMatrix;
uniform mat4 ModelViewProjectionMatrix;

out vec3 VNormal;

void main()
{
	VNormal = (ModelMatrix * vec4(Normal, 0.0)).xyz;
	
	vec4 vertex = ModelMatrix * vec4(Vertex * Size, 1.0);
	
	gl_Position = ModelViewProjectionMatrix * vec4(Vertex * Size, 1.0);
}
