#version 400

in vec2 Vertex;

uniform vec2 TexCoordOrigin;
uniform vec2 TexCoordScale;

uniform sampler2D HeightsTexture;

uniform float WorldPatchSize;
uniform vec2 WorldOrigin;

void main()
{
	// The tessellation control shader needs to project an actual point to measure screen space size.
	// Otherwise this could just be in the tessellation evaluation shader.
	
	float height = texture(HeightsTexture, TexCoordOrigin + vec2(Vertex.x, -Vertex.y) * TexCoordScale).x;
	
	vec3 position = vec3(
		WorldOrigin.x + Vertex.x * WorldPatchSize,
		height,
		WorldOrigin.y + Vertex.y * WorldPatchSize);
		
	gl_Position = vec4(position, 1.0);
}
